unit Main;

interface

Uses FontExportPlugin;

Procedure GetPluginInfo(Var PI: TPluginInfo); cdecl; export;
Procedure SimpleExport(const Data: TSimpleData); cdecl; export;
function GetPluginVersion():integer; cdecl; export;

implementation

uses Windows, SysUtils, Dialogs, Classes;


function GetPluginVersion():integer; cdecl;
begin
  result := fntPluginVersion2;
end;

Procedure GetPluginInfo(Var PI: TPluginInfo);  cdecl;
begin
  PI.Name := 'Font File';
  PI.PluginType := ptSimple;
  PI.poHasExtension := true;
  PI.poWantFilename := true;
  PI.Ext := 'fnt';
end;



Procedure SaveTGA(const data: TSimpleData);
const
   TGAheader : array [0..11] of byte = (0,0,2,0,0,0,0,0,0,0,0,0);

var
  header : array [0..5] of byte;									// First 6 Useful Bytes From The Header
  X, Y: integer;
  bmp, alpha: PByte;
  col: array[0..3] of byte;
  f: TFileStream;
begin
  f := TFileStream.Create(data.Filename, fmOpenWrite or fmCreate);

  f.Write(TGAheader, sizeof(TGAheader));

  header[0] := data.TexWidth mod 256;
  header[1] := data.TexWidth div 256;
  header[2] := data.TexHeight mod 256;
  header[3] := data.TexHeight div 256;
  header[4] := 32; //bpp;

  f.Write(header, sizeof(header));


  for Y := data.texHeight-1 downto 0 do
  begin

    bmp := data.RGB;
    alpha := data.Alpha;
    inc(bmp, y*3*(data.texWidth));
    inc(alpha, y*(data.texWidth));

    For X := 0 to data.texWidth-1 do
    begin
       col[0] := bmp^;
       inc(bmp);
       col[1] := bmp^;
       inc(bmp);
       col[2] := bmp^;
       inc(bmp);
       col[3] := alpha^;
       inc(alpha);

       f.Write(col[0], 4);

    end;
  end;



  f.Free;


end;




Procedure SimpleExport(const Data: TSimpleData); cdecl;
var F: TFileStream;
    I: integer;
    X1,Y1, X2,Y2 : double;
    Header: array[0..3] of char;
    Cur: PCharacterData;
    pos: int64;
begin

   SaveTGA(data);  //Save the tga first.


   Header[0] := 'F'; //Font
   Header[1] := 'S'; //Studio
   Header[2] := 't'; //Header
   Header[3] := 'd'; //

   F := nil;
   try
     F := TFileStream.Create(data.filename, fmOpenWrite); //Open the TGA file
     F.Seek(0, soFromEnd); //Move to the end;
     pos := F.Position;    //take the position

     F.Write(Header[0], 4);

     F.Write(data.Numchars, sizeof(Cardinal));
     F.Write(data.SpaceWidth, Sizeof(Cardinal));

     Cur := data.CharData;

     for I := 0 to data.NumChars-1 do
     begin
       X1 := Cur.X;
       Y1 := Cur.Y;
       X2 := Cur.X+Cur.Wid;
       Y2 := Cur.Y+Cur.Hgt;

       X1 := X1/data.texWidth;
       X2 := X2/data.texWidth;
       Y1 := Y1/data.texHeight;
       Y2 := Y2/data.texHeight;


       F.Write(Cur.char, sizeof(Widechar));
       F.Write(Cur.A , sizeof(integer));
       F.Write(Cur.C , sizeof(integer));

       F.Write(Cur.Wid , sizeof(integer));
       F.Write(Cur.Hgt , sizeof(integer));

       F.Write(X1, sizeof(double));
       F.Write(Y1, sizeof(double));
       F.Write(X2, sizeof(double));
       F.Write(Y2, sizeof(double));
       inc(cur);
     end;

     F.Write(header, 2);
     F.Write(pos, sizeof(int64)); //Write where you can find the beginning of the data section, right at the end of the file.

   finally
    if Assigned(F) then F.Free;
   end;
end;







end.
