unit Main;

interface

Uses FontExportPlugin;

Procedure GetPluginInfo(Var PI: TPluginInfo); cdecl; export;
Procedure DataExport(const Data: TCharactersData);  cdecl; export;
function GetPluginVersion():integer; cdecl; export;


implementation

uses Windows, SysUtils;

function GetPluginVersion():integer; cdecl;
begin
  Result := fntPluginVersion2;
end;


Procedure GetPluginInfo(Var PI: TPluginInfo);  cdecl;
begin
  PI.Name := 'XML File';
  PI.PluginType := ptData;
  PI.poHasExtension := true;
  PI.poWantFilename := true;
  PI.Ext := 'xml';
end;




Procedure DataExport(const Data: TCharactersData); cdecl;
var F: Textfile;
    cur: PCharacterData;
    I: integer;
    X1,Y1, X2,Y2 : double;

begin

   try


     AssignFile(F, data.filename);
     Rewrite(F);

     writeln(F, '<?xml version="1.0" encoding="UTF-8" ?>');
     writeln(F, '<font  numchars="', data.NumChars,
                     '" spacewidth="',data.SpaceWidth,'">');

     writeln(F, '<characters>');

     cur := data.CharData; //Initialise the pointer to the start of the character data array.

     for I := 0 to data.NumChars-1 do
     begin
       X1 := Cur.X;
       Y1 := Cur.Y;
       X2 := Cur.X+Cur.Wid;
       Y2 := Cur.Y+Cur.Hgt;

       X1 := X1/data.texWidth;
       X2 := X2/data.texWidth;
       Y1 := Y1/data.texHeight;
       Y2 := Y2/data.texHeight;

       write(F, '<chardata char="', integer(Cur.char));
       write(F,     '" A="', Cur.A );
       write(F,     '" C="', Cur.C );
       write(F,     '" wid="', Cur.Wid );
       write(F,     '" hgt="', Cur.Hgt );
       write(F,     '" X1="',floattostr(X1));
       write(F,     '" Y1="',floattostr(Y1));
       Write(F,     '" X2="',floattostr(X2));
       Write(F,     '" Y2="',floattostr(Y2));
       Writeln(F,   '" />');

       inc(cur); //move the cursor to the next character data record.

     end;

     writeln(F, '</characters>');
     writeln(F, '</font>');
   finally
     CloseFile(F);
   end;
end;

end.
